freemarker.template

## Class DefaultIterableAdapter

- java.lang.Object
- - freemarker.template.WrappingTemplateModel
  - - freemarker.template.DefaultIterableAdapter

All Implemented Interfaces:
  WrapperTemplateModel, AdapterTemplateModel, TemplateCollectionModel, TemplateModel, TemplateModelWithAPISupport, Serializable

    public class DefaultIterableAdapter
    extends WrappingTemplateModel
    implements TemplateCollectionModel, AdapterTemplateModel, WrapperTemplateModel, TemplateModelWithAPISupport, Serializable

Adapts an `Iterable` to the corresponding `TemplateModel` interface(s), most importantly to `TemplateCollectionModel`. This should only be used if `Collection` is not implemented by the adapted object, because then `DefaultListAdapter` and `DefaultNonListCollectionAdapter` gives more functionality.

Thread safety: A `DefaultIterableAdapter` is as thread-safe as the `Iterable` that it wraps is. Normally you only have to consider read-only access, as the FreeMarker template language doesn't provide mean to call `Iterator` modifier methods (though of course, Java methods called from the template can violate this rule).

This adapter is used by `DefaultObjectWrapper` if its `iterableSupport` property is `true`, which is not the default for backward compatibility (so you have to set it explicitly).

Since:
  2.3.25
See Also:
  Serialized Form

### Field Summary

### Fields inherited from interface freemarker.template.TemplateModel

`NOTHING`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static DefaultIterableAdapter` `adapt(Iterable<?> iterable, ObjectWrapperWithAPISupport wrapper)` Factory method for creating new adapter instances.
`Object` `getAdaptedObject(Class hint)` Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
`TemplateModel` `getAPI()` Returns the model that exposes the (Java) API of the value.
`Object` `getWrappedObject()` Retrieves the original object wrapped by this model.
`TemplateModelIterator` `iterator()` Retrieves a template model iterator that is used to iterate over the elements in this collection.

### Methods inherited from class freemarker.template.WrappingTemplateModel

`getDefaultObjectWrapper, getObjectWrapper, setDefaultObjectWrapper, setObjectWrapper, wrap`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### adapt

    public static DefaultIterableAdapter adapt(Iterable<?> iterable,
                                               ObjectWrapperWithAPISupport wrapper)

Factory method for creating new adapter instances.

Parameters:
  `iterable` - The collection to adapt; can't be `null`.
  `wrapper` - The `ObjectWrapper` used to wrap the items in the array. Has to be `ObjectWrapperAndUnwrapper` because of planned future features.

#### iterator

    public TemplateModelIterator iterator()
                                   throws TemplateModelException

Description copied from interface: `TemplateCollectionModel`
Retrieves a template model iterator that is used to iterate over the elements in this collection.

Specified by:
  `iterator` in interface `TemplateCollectionModel`
Throws:
  `TemplateModelException`

#### getWrappedObject

    public Object getWrappedObject()

Description copied from interface: `WrapperTemplateModel`
Retrieves the original object wrapped by this model.

Specified by:
  `getWrappedObject` in interface `WrapperTemplateModel`

#### getAdaptedObject

    public Object getAdaptedObject(Class hint)

Description copied from interface: `AdapterTemplateModel`
Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.

Specified by:
  `getAdaptedObject` in interface `AdapterTemplateModel`
Parameters:
  `hint` - the desired class of the returned value. An implementation should make reasonable effort to retrieve an object of the requested class, but if that is impossible, it must at least return the underlying object as-is. As a minimal requirement, an implementation must always return the exact underlying object when `hint.isInstance(underlyingObject)` holds. When called with `java.lang.Object.class`, it should return a generic Java object (i.e. if the model is wrapping a scripting language object that is further wrapping a Java object, the deepest underlying Java object should be returned).
Returns:
  the underlying object, or its value accommodated for the hint class.

#### getAPI

    public TemplateModel getAPI()
                         throws TemplateModelException

Description copied from interface: `TemplateModelWithAPISupport`
Returns the model that exposes the (Java) API of the value. This is usually implemented by delegating to `ObjectWrapperWithAPISupport.wrapAsAPI(Object)`.

Specified by:
  `getAPI` in interface `TemplateModelWithAPISupport`
Throws:
  `TemplateModelException`